import { Component, OnInit } from "@angular/core";
import { CapabilityLauncherService } from "./services/capability-launcher.service";
import { Observable } from "rxjs";
import { CapabilityRequest } from "./model/capability-request";
import { map } from "rxjs/operators";
import { CapabilityExecution } from "./model/capability-execution";

@Component({
  selector: "app-workspaces",
  templateUrl: "./workspaces.component.html",
  styleUrls: ["./workspaces.component.scss"],
})
export class WorkspacesComponent implements OnInit {
  public capabilityRequests: Array<CapabilityRequest> = [];
  public capabilityExecutions: Array<CapabilityExecution> = [];

  constructor(private capabilityLauncher: CapabilityLauncherService) {}

  ngOnInit(): void {}

  /**
   * OnClick method that creates a capability request for the null capability and submits it
   */
  nullButtonOnClick(): void {
    // Create capability request
    // TODO: Change this to request download capability execution
    this.capabilityLauncher.createRequest("null", "-g").subscribe(
      (requestResponse) => {
        this.capabilityRequests.push(requestResponse);
        if (requestResponse.id) {
          // Capability request created; ID found
          const requestId = requestResponse.id;
          // Submit capability request
          this.capabilityLauncher.submit(requestId).subscribe(
            (submitResponse) => {
              this.capabilityExecutions.push(submitResponse);
            },
            (error) => {
              console.log(error);
            }
          );
        }
      },
      (error) => {
        console.log(error);
      }
    );
  }
}
